//sixshooter.cs

//audio
datablock AudioProfile(sixshooterShotSound)
{
   filename    = "./revolver_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(sixshooterReloadSound)
{
   filename    = "./revolver_reload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(sixshooterReload2Sound)
{
   filename    = "./revolver_reload2.wav";
   description = AudioClose3d;
   preload = true;
};


AddDamageType("revolverB",   '<bitmap:add-ons/Weapon_Sixshooter/CI_revolver> %1',    '%2 <bitmap:add-ons/Weapon_Sixshooter/CI_revolver> %1',1,1);

datablock ProjectileData(sixshooterProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 65;
   directDamageType    = $DamageType::RevolverB;
   radiusDamageType    = $DamageType::RevolverB;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 10;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 20;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = gunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 165;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Sixshooter Bullet";
};

//////////
// item //
//////////
datablock ItemData(sixshooterItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./revolver_bushido3.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Sixshooter";
	iconName = "./icon_revolver";

	 // Dynamic properties defined by the scripts
	image = sixshooterImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(sixshooterImage)
{
   // Basic Item properties
   shapeFile = "./revolver_bushido3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = sixshooterProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Reload";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Ammo1";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

//reload passage!

	stateName[2]                     = "Reload";
	stateAllowImageChange[2]         = true;
	stateSequence[2]                = "Reload";
	stateScript[2]                  = "Reload";
	stateSequence[2]	= "Reloadpart1";
	stateTransitionOnTimeout[2]     = "Reload2";
	stateWaitForTimeout[2]			= true;
	stateTimeoutValue[2]				= 0.65;
	stateSound[2]					= sixshooterReloadSound;

	stateName[3]                     = "Reload2";
	stateAllowImageChange[3]         = true;
	stateSequence[3]                = "Reload";
	stateScript[3]                  = "Reload";
	stateSequence[3]	= "Reloadpart2";
	stateTransitionOnTimeout[3]     = "Ready";
	stateWaitForTimeout[3]			= true;
	stateTimeoutValue[3]				= 0.85;
	stateSound[3]					= sixshooterReload2Sound;

//ammo passage and firing
//first shot

	stateName[4]                    = "Ammo1";
	stateTransitionOnTimeout[4]     = "Ammo1Ready";
	stateTimeoutValue[4]            = 0.54;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= gunFlashEmitter;
	stateEmitterTime[4]				= 0.02;
	stateEmitterNode[4]				= "muzzleNode";
	stateSound[4]					= sixshooterShotSound;

	stateName[5]                     = "Ammo1Ready";
	stateTransitionOnTriggerDown[5]  = "Ammo2";
	stateAllowImageChange[5]         = true;
	stateSequence[5]	= "Ready";

//second shot

	stateName[6]                    = "Ammo2";
	stateTransitionOnTimeout[6]     = "Ammo2Ready";
	stateTimeoutValue[6]            = 0.54;
	stateFire[6]                    = true;
	stateAllowImageChange[6]        = false;
	stateSequence[6]                = "Fire";
	stateScript[6]                  = "onFire";
	stateWaitForTimeout[6]			= true;
	stateEmitter[6]					= gunFlashEmitter;
	stateEmitterTime[6]				= 0.02;
	stateEmitterNode[6]				= "muzzleNode";
	stateSound[6]					= sixshooterShotSound;

	stateName[7]                     = "Ammo2Ready";
	stateTransitionOnTriggerDown[7]  = "Ammo3";
	stateAllowImageChange[7]         = true;
	stateSequence[7]	= "Ready";

//third shot

	stateName[8]                    = "Ammo3";
	stateTransitionOnTimeout[8]     = "Ammo3Ready";
	stateTimeoutValue[8]            = 0.54;
	stateFire[8]                    = true;
	stateAllowImageChange[8]        = false;
	stateSequence[8]                = "Fire";
	stateScript[8]                  = "onFire";
	stateWaitForTimeout[8]			= true;
	stateEmitter[8]					= gunFlashEmitter;
	stateEmitterTime[8]				= 0.02;
	stateEmitterNode[8]				= "muzzleNode";
	stateSound[8]					= sixshooterShotSound;

	stateName[9]                     = "Ammo3Ready";
	stateTransitionOnTriggerDown[9]  = "Ammo4";
	stateAllowImageChange[9]         = true;
	stateSequence[9]	= "Ready";

//fourth shot

	stateName[10]                    = "Ammo4";
	stateTransitionOnTimeout[10]     = "Ammo4Ready";
	stateTimeoutValue[10]            = 0.54;
	stateFire[10]                    = true;
	stateAllowImageChange[10]        = false;
	stateSequence[10]                = "Fire";
	stateScript[10]                  = "onFire";
	stateWaitForTimeout[10]			= true;
	stateEmitter[10]					= gunFlashEmitter;
	stateEmitterTime[10]				= 0.02;
	stateEmitterNode[10]				= "muzzleNode";
	stateSound[10]					= sixshooterShotSound;

	stateName[11]                     = "Ammo4Ready";
	stateTransitionOnTriggerDown[11]  = "Ammo5";
	stateAllowImageChange[11]         = true;
	stateSequence[11]	= "Ready";

//fifth shot

	stateName[12]                    = "Ammo5";
	stateTransitionOnTimeout[12]     = "Ammo5Ready";
	stateTimeoutValue[12]            = 0.54;
	stateFire[12]                    = true;
	stateAllowImageChange[12]        = false;
	stateSequence[12]                = "Fire";
	stateScript[12]                  = "onFire";
	stateWaitForTimeout[12]			= true;
	stateEmitter[12]					= gunFlashEmitter;
	stateEmitterTime[12]				= 0.02;
	stateEmitterNode[12]				= "muzzleNode";
	stateSound[12]					= sixshooterShotSound;

	stateName[13]                     = "Ammo5Ready";
	stateTransitionOnTriggerDown[13]  = "Ammo6";
	stateAllowImageChange[13]         = true;
	stateSequence[13]	= "Ready";

//sixth shot and loop back to reload

	stateName[14]                    = "Ammo6";
	stateTransitionOnTimeout[14]     = "Reload";
	stateTimeoutValue[14]            = 0.34;
	stateFire[14]                    = true;
	stateAllowImageChange[14]        = false;
	stateSequence[14]                = "Fire";
	stateScript[14]                  = "onFire";
	stateWaitForTimeout[14]			= true;
	stateEmitter[14]					= gunFlashEmitter;
	stateEmitterTime[14]				= 0.02;
	stateEmitterNode[14]				= "muzzleNode";
	stateSound[14]					= sixshooterShotSound;
};

function sixshooterImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}
